#ifndef __SQL_STORAGE_QUERY_H
#define __SQL_STORAGE_QUERY_H

#include "var-expand.h"
#include "sql-api.h"

enum sql_storage_query_id {
	SQ_MAILBOX_SYNC,
	SQ_MAILBOX_SYNC_NEWMSGS,
	SQ_MAILBOX_SYNC_LIST_UIDS,
	SQ_MAILBOX_SYNC_LIST_FLAGS,
	SQ_MAILBOX_SYNC_EXPUNGE,
	SQ_MAILBOX_SYNC_UPDATE,
	SQ_MAILBOX_SAVE_INIT,
	SQ_MAILBOX_BODY_INIT,
	SQ_MAILBOX_BODY_TEMPLATE,

	SQ_COUNT
};

struct sql_storage_query {
	const char *name;
	const char *query;
};

extern struct sql_storage_query sql_storage_queries[SQ_COUNT];

struct sql_result *
sql_storage_query(struct sql_storage *storage, enum sql_storage_query_id id,
		  const struct var_expand_table *variables);
int sql_storage_query_row(struct sql_storage *storage, enum sql_storage_query_id id,
			  const struct var_expand_table *variables,
			  const struct sql_field_def *fields,
			  void *dest, size_t dest_size,
			  struct sql_result **result_r);
void sql_storage_update(struct sql_transaction_context *trans,
			enum sql_storage_query_id id,
			const struct var_expand_table *variables);

void sql_storage_query_failed(struct sql_storage *storage,
			      enum sql_storage_query_id id,
			      struct sql_result *result);

#endif
