#ifndef __SQL_SYNC_H
#define __SQL_SYNC_H

enum mailbox_sync_flags;
struct mailbox;

struct sql_sync_context {
	struct sql_mailbox *mbox;
        struct mail_index_sync_ctx *index_sync_ctx;
	struct mail_index_view *sync_view;

	struct mail_index_transaction *trans;
	struct sql_transaction_context *sql_trans;
};

int sql_mailbox_sync_begin(struct sql_mailbox *mbox,
			   struct sql_sync_context **ctx_r);
int sql_mailbox_sync_finish(struct sql_sync_context **ctx, bool success);
int sql_mailbox_sync(struct sql_mailbox *mbox);

struct mailbox_sync_context *
sql_mailbox_sync_init(struct mailbox *box, enum mailbox_sync_flags flags);

#endif
